#include <iostream>

long long kupovine[100000];
long long pakovanja[100000];

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int n, q;
    std::cin >> n >> q;

    
    long long ostalo = 0;
    for (int i = 0; i < n; i++) {
        long long dan, p;
        std::cin >> dan >> p;

        ostalo = std::max(ostalo - dan, 0LL);
        kupovine[i] = ostalo + dan;
        pakovanja[i] = kupovine[i] + p;
        ostalo = dan + p;
    }

    
    while (q--) {
        long long z;
        std::cin >> z;

        long long result = 0;
        for (int i = 0; i < n && kupovine[i] <= z; i++) {
            if (pakovanja[i] > z) {
                result += z - kupovine[i] + 1;
                break;
            }
            result += pakovanja[i] - kupovine[i];
        }

        std::cout << result << '\n';
    }

    return 0;
}